#Main File to test the Graph Class
#L & S Gonnord, 2016
from LibGraphes import *

def main():
    g = { "a" : ["d"],
          "b" : ["c"],
          "c" : ["b", "d", "e"],
          "d" : ["a", "c"],
          "e" : ["c"],
          "f" : []
    }
    g2 = { "r3" : ["r1", "r2"],
           "r2" : ["r3", "r1", "c", "a"],
           "r1" : ["r3", "r2", "c"],
           "c"  : ["r1", "r2", "b", "a", "d", "e"],
           "b"  : ["a", "c", "d", "e"],
           "e"  : ["b", "c", "d"],
           "a"  : ["b", "c", "d", "r2"],
           "d"  : ["a", "b", "c", "e"]
    }
    #two graphs
    graph = Graph(g)
    graph2 = Graph(g2)
        
    print("Vertices of graph:")
    print(graph.vertices())

    print("Edges of graph:")
    print(graph.edges())

    print("Add vertex:")
    graph.add_vertex("z")
    
    print("Vertices of graph:")
    print(graph.vertices())

    print("Add an edge:")
    graph.add_edge(("a","z"))
    print("Add an edge:")
    graph.add_edge(("a","a"))
    print("Vertices of graph:")
    print(graph.vertices())

    print("Edges of graph:")
    print(graph.edges())

    print('Adding an edge {"x","y"} with new vertices:')
    graph.add_edge({"x","y"})
    print("Vertices of graph:")
    print(graph.vertices())
    print("Edges of graph:")
    print(graph.edges())

    graph.delete_vertex('c')
    graph.dfs_traversal('a') #['a', 'z', 'd', 'c', 'e', 'b']
    graph.dfs_traversal('d') #['d', 'c', 'e', 'b', 'a', 'z']
    graph.bfs_traversal('d') #['d', 'a', 'c', 'z', 'b', 'e']
    
    graph.color(0)   #False
    graph.color(3)    #{'a': 1, 'c': 1, 'b': 0, 'e': 0, 'd': 0, 'f': 0, 'y': 0, 'x': 1, 'z': 0}

if __name__ == '__main__':
    main()
